program project1;

uses
  Cairo,
  glib2,
  gdk2,
  gtk2;

type
  Tglob = record
    Count: integer;
    coordx: array [0..99] of double;
    coordy: array [0..99] of double;
  end;
var
  glob: Tglob;

  procedure do_drawing(cr: Pcairo_t);
  var
    i, j: integer;
  begin
    cairo_set_source_rgb(cr, 0, 0, 0);
    cairo_set_line_width(cr, 0.5);
    for i := 0 to glob.Count - 1 do begin
      for j := 0 to glob.Count - 1 do begin
        cairo_move_to(cr, glob.coordx[i], glob.coordy[i]);
        cairo_move_to(cr, glob.coordx[j], glob.coordy[j]);
      end;
    end;
    glob.Count := 0;
    cairo_stroke(cr);
  end;

  function on_draw_event(widget: PGtkWidget; cr: Pcairo_t; user_data: Pgpointer): gboolean;  //   cdecl;
  begin
    do_drawing(cr);
    Result := False;
  end;

  function clicked(widget: PGtkWidget; event: PGdkEventButton; user_data: gpointer): gboolean;
  begin
    if event^.button = 1 then begin
      glob.coordx[glob.Count] := event^.x;
      Inc(glob.Count);
      glob.coordx[glob.Count] := event^.x;
    end;
    if event^.button = 3 then begin
      gtk_widget_queue_draw(widget);
    end;
    Result := True;
    WriteLn(event^.button);
  end;

  function main: integer;
  var
    window, darea: PGtkWidget;
  begin
    glob.Count := 0;

    gtk_init(@argc, @argv);

    window := gtk_window_new(GTK_WINDOW_TOPLEVEL);

    darea := gtk_drawing_area_new;
    gtk_container_add(GTK_CONTAINER(window), darea);

    gtk_widget_add_events(window, GDK_BUTTON_PRESS_MASK);

    g_signal_connect(G_OBJECT(darea), 'draw', G_CALLBACK(@on_draw_event), nil);
    g_signal_connect(window, 'destroy', G_CALLBACK(@gtk_main_quit), nil);
    g_signal_connect(window, 'button-press-event', G_CALLBACK(@clicked), nil);

    gtk_window_set_position(GTK_WINDOW(window), GTK_WIN_POS_CENTER);
    gtk_window_set_default_size(GTK_WINDOW(window), 400, 300);
    gtk_window_set_title(GTK_WINDOW(window), 'Lines');

    gtk_widget_show_all(window);

    gtk_main;
    Result := 0;
  end;

begin
  main;
end.
